<h1>News list</h1>

<div *ngIf="isServiceUnavailable" class="service-unavailable">
  <i class="far fa-frown fa-5x"></i>
  <h2>Przepraszamy, serwis jest niedostępny</h2>
  <button mat-raised-button (click)="refresh()">
    <i class="fas fa-sync-alt"></i>
    <span> Spróbuj ponownie</span>
  </button>
</div>

<form (ngSubmit)="getNews(pageSize, pageIndex)" *ngIf="!isServiceUnavailable" class="filters">
  <mat-form-field>
    <mat-label>Wyszukaj</mat-label>
    <input matInput placeholder="Wyszukaj" [(ngModel)]="newsForm.q" [ngModelOptions]="{standalone: true}">
  </mat-form-field>

  <mat-form-field>
    <mat-label>Język</mat-label>
    <mat-select [(value)]="newsForm.country">
      <mat-option>Wszystkie</mat-option>
      <mat-option *ngFor="let language of languages" [value]="language.value">
        {{language.viewValue}}
      </mat-option>
    </mat-select>
  </mat-form-field>

  <mat-form-field>
    <mat-label>Kategorie</mat-label>
    <mat-select [(value)]="newsForm.category" required>
      <mat-option *ngFor="let category of categories" [value]="category.value">
        {{category.viewValue}}
      </mat-option>
    </mat-select>
  </mat-form-field>

  <button mat-raised-button type="submit">
    <i class="far fa-save"></i>
    <span> Zapisz</span>
  </button>
</form>

<mat-paginator [length]="length"
               [pageSize]="pageSize"
               [pageSizeOptions]="pageSizeOptions"
               (page)="changePage($event)"
               class="card"
               *ngIf="!isServiceUnavailable">
</mat-paginator>

<mat-spinner *ngIf="isArticleLoading" class="spinner"></mat-spinner>

<mat-card class="card" *ngFor="let article of articleList$ | async">
  <mat-card-header>
    <mat-card-title>{{article.title}}</mat-card-title>
    <mat-card-subtitle>
      {{article.date | date: 'yyyy-MM-dd HH:mm'}}
      {{article.author ? ', ' + article.author : ''}}
      {{article.sourceName ? ', ' + article.sourceName : ''}}
    </mat-card-subtitle>
  </mat-card-header>
  <img mat-card-image src="{{article.imageUrl}}" alt="">
  <mat-card-content>
    <p>
      {{article.description}}
    </p>
  </mat-card-content>
</mat-card>

<mat-paginator [length]="length"
               [pageSize]="pageSize"
               [pageSizeOptions]="pageSizeOptions"
               [pageIndex]="pageIndex"
               (page)="changePage($event)"
               class="card"
               *ngIf="!isArticleLoading && !isServiceUnavailable && length > 0">
</mat-paginator>
